-- Turbine Imports..
import "Turbine"; 
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Morgantine.Wenda.Localization";
import "Morgantine.Wenda.AddCallBack";
import "Morgantine.Wenda.DropDown";
import "Morgantine.Wenda.VindarPatch"
import "Morgantine.Wenda.Window";
import "Morgantine.Wenda.Save";
import "Morgantine.Wenda.OptionsPanel";
import "Morgantine.Wenda.CheckEveryone";
LocalPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
PlayerName = LocalPlayer:GetName()
Backpack = LocalPlayer:GetBackpack()
EffectList = LocalPlayer:GetEffects()
emptyslots = 0
subtimeout = 0
carryalls = ""

function GetEmptySlots()
      --Find the number of empty slots in inventory
   local backpack = LocalPlayer:GetBackpack();
   local size = backpack:GetSize();
   local empty = 0
   SubServicesItem = nil
   for i = 1, size, 1 do
      local item = backpack:GetItem(i);
      if item then
         if item:GetName() == TI["TownServices"] then
            SubServicesItem = item
         end
      end
      if not item then
         empty = empty + 1
      end
   end
   if (SubServicesItem~=nil and Field~=nil and Field["quick"]~=nil) then
      Field["quick"]:SetItem(SubServicesItem) --can't hurt to do it again, eh?
   end
   emptyslots = empty
end
function TimeRemaining(effect)
   local now = Turbine.Engine.GetGameTime();
   local start = effect:GetStartTime();
   local duration = effect:GetDuration();
   if duration > 1e8 then
      return 0
   else
      return (start+duration-now)/3600; --returns hours
   end

end
function GetSubTimeout()
   --How long until subscriber benefits expire?
   EffectList = LocalPlayer:GetEffects();
   local effectCount = EffectList:GetCount();
   local result = "0"
   for i = 1, effectCount, 1 do
      local effect = EffectList:Get(i);
      if effect:GetName() == TI["SubBuffs"] then
         local start_time = effect:GetStartTime();
         if Settings[PlayerName] ~= effect:GetStartTime() then
            Settings[PlayerName] = math.floor(effect:GetStartTime());
            Save()
         end
         result = string.format("%.1f",TimeRemaining(effect)/24);
         break
      end
   end
   if (result == "0") then --not subscribed
      Settings[PlayerName] = 0
   end
   subtimeout = result
end
function GetCarryAlls()
   local backpack = LocalPlayer:GetBackpack();
   local size = backpack:GetSize();
   local result = "";
   for i = 1, size, 1 do
      local item = backpack:GetItem(i);
      if item then
         local name = item:GetName();
         local lname = string.lower(name);
         if string.find(lname,TCA["carryall"],1,true) ~= nil then
            local size = nil
            for duh,sz in pairs(TCA.sizes) do
               if string.find(lname,sz,1,true) ~= nil then
                  size = string.upper(string.sub(sz,1,1))
               end
            end
            if size then
               local typ = nil
               for t,ab in pairs(TCA.types) do
                  if string.find(lname,t,1,true) ~= nil then
                     typ = ab
                  end
               end
               if typ then
                  result = result .. typ .. '-' .. size .. " "
               end
            end
         end
      end
   end
   carryalls = result
end

function CheckBackpack(sender,args)
   GetCarryAlls()
   GetEmptySlots()
   Display()
end
function CheckEffects(sender,args)
   GetSubTimeout()
   Display()
end
--
ItemRemovedTimer = Turbine.UI.Control();
ItemRemovedTimer.Update = function(sender, args)
   ItemRemovedTimer:SetWantsUpdates(false);
   CheckBackpack()
end
function WaitForRemoval(sender, args)
   ItemRemovedTimer:SetWantsUpdates(true);
end
--
AddCallback(Backpack,"ItemAdded",CheckBackpack);
AddCallback(Backpack,"ItemRemoved",WaitForRemoval);
AddCallback(Backpack,"ItemMoved",CheckBackpack);
AddCallback(Backpack,"SizeChanged",CheckBackpack);
AddCallback(EffectList,"EffectAdded",CheckEffects);
AddCallback(EffectList,"EffectRemoved",CheckEffects);

GetSubTimeout()
GetEmptySlots()
GetCarryAlls()
startCarry = carryalls
DrawWindow()
SwitchWindows(1)
Display()
